unit MCoPRotatableImage;

interface

uses
  Windows, SysUtils, Graphics, Jpeg, ExtCtrls, Types, Classes;

type
  TRotatableImage = class(TImage)
  private
    { Private declarations }
    IB:Graphics.TBitmap;
    RA:Real;
    LPC:TNotifyEvent;
    procedure SetRA(S:Real);
    procedure SetHome(S:String);
    function GetHome:String;
    procedure Ref;
    procedure PictureChanged(Sender:TObject);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property RotationAngle:Real read RA write SetRA;
    property Homepage:String read GetHome write SetHome stored false;
  end;

procedure Register;

{$R MCoPRotatableImage.dcr}

implementation

constructor TRotatableImage.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
RA:=0;
LPC:=Picture.OnChange;
Picture.OnChange:=PictureChanged;
if not(csDesigning in ComponentState) then ref;
end;

destructor TRotatableImage.Destroy;
begin
if IB<>nil then IB.Free;
inherited Destroy;
end;

function TRotatableImage.GetHome:String;
begin
Result:='http://www.dihav.com';
end;

procedure TRotatableImage.SetHome(S:String);
begin
//
end;

procedure TRotatableImage.SetRA(S:Real);
begin
RA:=s;
ref;
end;

procedure TRotatableImage.Ref;
var
 p:array[0..3] of tpoint;
 k,w,h:integer;
 o,r,i:real;
 b:Graphics.TBitmap;
begin
if IB=nil then exit;
w:=IB.Width;
h:=IB.Height;
p[0]:=point(-w div 2,h div 2);
p[1]:=point(w div 2,h div 2);
p[2]:=point(-w div 2,-h div 2);
i:=sqrt(sqr(w/2)+sqr(h/2));
for k:=0 to 2 do
 begin
 o:=arctan(p[k].Y/p[k].X);
 if p[k].X<0 then o:=o+pi;
 r:=sqrt(sqr(p[k].X)+sqr(p[k].Y));
 p[k].X:=round(cos(o+(RA*pi/180))*r+i);
 p[k].Y:=round(i-sin(o+(RA*pi/180))*r);
 end;
b:=Graphics.TBitmap.Create;
b.Width:=round(i*2);
b.Height:=round(i*2);
b.Canvas.Brush.Color:=IB.TransparentColor;
b.Canvas.FloodFill(0,0,clwhite,fssurface);
plgblt(b.canvas.Handle,p,IB.Canvas.Handle,0,0,w,h,0,0,0);
Picture.OnChange:=LPC;
Picture.Assign(b);
Picture.OnChange:=PictureChanged;
b.Free;
end;

procedure TRotatableImage.PictureChanged(Sender:TObject);
begin
if csDesigning in ComponentState then
 begin
 LPC(Self);
 exit;
 end;
if IB<>nil then IB.Free;
IB:=nil;
if Picture.Width=0 then exit;
IB:=Graphics.TBitmap.Create;
IB.Width:=Picture.Graphic.Width;
IB.Height:=Picture.Graphic.Height;
if Transparent then
 begin
 IB.Canvas.Brush.Color:=Picture.Bitmap.TransparentColor;
 IB.Canvas.FloodFill(0,0,clwhite,fssurface);
 end;
IB.Canvas.Draw(0,0,Picture.Graphic);
ref;
end;

procedure Register;
begin
  RegisterComponents('dihav', [TRotatableImage]);
end;

end.
